import java.awt.*;
import java.awt.event.*;
import java.util.Calendar;
import java.util.GregorianCalendar;
import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.event.*;

public class Calendario extends JPanel{

	private JComboBox combobox;
	private Cella[]days;
	private JSpinner spinner;
	private Cella_giorno_settimana[] week;
	
	private String data;
	private JTextField date;
	private JFrame frame;
	
	public Calendario(JTextField d,JFrame f){
		
		
		data = "";
		date = d;
		
		frame = f;
		
		this.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		this.setLayout(new BorderLayout());
		this.setBorder(BorderFactory.createLineBorder(Color.black));
		
		//pannello che contiene la combobox e la spinner
		JPanel combospinnerpanel = new JPanel();
		FlowLayout layout = new FlowLayout(FlowLayout.LEFT,50,5);
		combospinnerpanel.setLayout(layout);
		
		ComboBoxModel jComboBox1Model = new DefaultComboBoxModel(new String[] { "Gennaio", "Febbraio", "Marzo", "Aprile", "Maggio", "Giugno", "Luglio", "Agosto", "Settembre","Ottobre", "Novembre", "Dicembre" });
		combobox = new JComboBox();
		combobox.setModel(jComboBox1Model);
		combobox.setBounds(14, 14, 98, 28);
		combospinnerpanel.add(combobox);
		combobox.addActionListener(new MioListener());
		//spinner
		Calendar calendar = new GregorianCalendar();
		int currentYear = calendar.get(Calendar.YEAR);
		SpinnerModel jSpinner1Model = new SpinnerNumberModel(currentYear,currentYear - 100,currentYear + 100,1);
		spinner = new JSpinner();
		spinner.setModel(jSpinner1Model);
		spinner.setEditor(new JSpinner.NumberEditor(spinner, "#"));
		spinner.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
		spinner.getEditor().setBorder(new LineBorder(new java.awt.Color(0,0,0),1,false));
		spinner.getEditor().setEnabled(false);
		spinner.setBounds(495, 14, 98, 28);
		combospinnerpanel.add(spinner);
		spinner.addChangeListener(listener);
		this.add(combospinnerpanel,BorderLayout.NORTH);
		
		//pannello che contiene i giorni del mese (da 1 a 31)
		JPanel panelgiorni = new JPanel();
		
		GridLayout panelgiornilayout = new GridLayout(6, 7);
		panelgiornilayout.setHgap(5);
		panelgiornilayout.setVgap(5);
		panelgiornilayout.setColumns(7);
		panelgiornilayout.setRows(6);
		panelgiorni.setLayout(panelgiornilayout);
		this.add(panelgiorni,BorderLayout.SOUTH);
		//bottoni giorni da 1 a 31
		days = new Cella[42];
		
		for (int i=0; i<42;i++){
			 Cella cella = new Cella(this);
			 days[i]= cella;
			 
		 }
		for (int i=0; i<42; i++){
			
			panelgiorni.add(days[i]);
			days[i].clear(false);
			 
		}
		
		leggistatocombospinner();
		
		//pannello che contiene il nome dei giorni della settimana
		JPanel settpanel = new JPanel();
		GridLayout settpanellayout = new GridLayout(1,0);
		settpanellayout.setHgap(5);
		settpanellayout.setVgap(5);
		settpanellayout.setColumns(0);
		settpanellayout.setRows(1);
		settpanel.setLayout(settpanellayout);
		this.add(settpanel,BorderLayout.CENTER);
		
		//label giorni della settimana lun/mar/mer etc..
		
		week = new Cella_giorno_settimana[7];
		
		for (int i=0; i<7;i++){
			Cella_giorno_settimana cella = new Cella_giorno_settimana();
			 week[i]= cella;
		 }
		
        for (int i=0; i<7; i++){
			
        	settpanel.add(week[i]);
			
			 
		}
		String lun = new String("lun");
		week[0].setGiorno(lun);
		String mar = new String("mar");
		week[1].setGiorno(mar);
		String mer = new String("mer");
		week[2].setGiorno(mer);
		String gio = new String("gio");
		week[3].setGiorno(gio);
		String ven = new String("ven");
		week[4].setGiorno(ven);
		String sab = new String("sab");
		week[5].setGiorno(sab);
		String dom = new String("dom");
		week[6].setGiorno(dom);
		
		//this.add(combospinnerpanel,BorderLayout.NORTH);
		//this.add(panelgiorni,BorderLayout.CENTER);
		
	}
	 
	 public class MioListener implements ActionListener {
		   public void actionPerformed(ActionEvent ae) {
		      JComboBox jcb = (JComboBox) ae.getSource();
		      azzeracelle(); //azzero le celle della precedente visualizzazione per non creare sovrascrizioni
		      leggistatocombospinner();
		   }
	}
	 
	 ChangeListener listener = new ChangeListener() {
	      public void stateChanged(ChangeEvent e) {
	    	JSpinner js = (JSpinner) e.getSource();
	    	azzeracelle();
	    	leggistatocombospinner();
	      }
	}; 
	 
	 public void azzeracelle(){
			
			for (int i=0; i<42; i++)
				days[i].clear(false);
		}
	 public void leggistatocombospinner (){
			
			
			int mm= combobox.getSelectedIndex();
			int yy=((Integer)spinner.getValue()).intValue();
			setCalendario(yy,mm);
		}
	 
	 public String getMese(){
	 	return combobox.getSelectedItem()+"";
	 }
	 public String getAnno(){
	 	return spinner.getValue()+"";
	 }
	 public void formaData(int giorno){
	 	data = giorno + " " + getMese() + " " + getAnno();
	 	date.setText(data);
	 	frame.dispose();
	 }
	 public String getData(){
	 	return data;
	 }
	 
	 public void setCalendario (int anno, int mese){
			
			GregorianCalendar c = new GregorianCalendar (anno,mese,1);
			int lastday = c.getActualMaximum (Calendar.DAY_OF_MONTH);
			int weekday = c.get (Calendar.DAY_OF_WEEK);
			int giorno = (weekday + 5) % 7;
			int maxday = giorno+(lastday-1);
		        for (int i=giorno, y=1; i<=maxday ;i++, y++){
		        	 
		        	days[i].clear(true);
		        	days[i].setGiorno(y);
		        }
		          
		}
}