import java.io.*;
import java.lang.*;
import java.util.*;

public class NuSMV {

	public static String getEvento(boolean[][] m,String[] attivita){
		String evento = "evento : { ";
		
		for(int i = 0; i < m.length; i ++){
			for(int j = 0; j < m[0].length; j++){
				if(m[i][j]){
					evento = evento + attivita[i]+attivita[j] + ",";
				}
			}
		}
		evento = evento +"null};";
		return evento;
	}
	public static String getStato(String[] attivita){
		String stato = "stato : { ";
		
		for(int i = 0; i < attivita.length; i ++){
			stato = stato + attivita[i] +",";
		}
		stato = stato.substring(0,stato.length()-1);
		
		stato = stato +"};";
		return stato;
	}
	public static String getModule(boolean[][] m,String[] att){
		String module = "MODULE diagramma\r\nVAR\r\n" + getStato(att)+"\r\n"+getEvento(m,att)+"\r\n";
		return module;
	}
	public static String getTrans(boolean[][] m,String[] att){
		String trans = "TRANS\r\ncase\r\n";
		for(int i = 0; i < m.length-1; i++){
			for(int j = 0; j < m[0].length; j++){
				if(m[i][j]){
					trans = trans + "stato = " + att[i]+ " &  evento = " + att[i]+att[j] + " : " + "next(stato) = "+att[j]+";\r\n";
				}
			}
		}
		trans = trans + "1 : next(stato) = stato;\r\nesac\r\n";
		return trans;
	}
	public static String getMain(boolean[][] m,String[] att,int at){
		String main = "MODULE main\r\nVAR\r\ndiagra : diagramma;\r\nASSIGN\r\ninit(diagra.stato):="+att[at]+";\r\nLTLSPEC\r\n";
		String formula = "(  diagra.stato = "+att[at]+" & (";
		
		for(int i = 0; i < m[0].length;i++){
			if(m[at][i]){
				formula = formula + "  diagra.evento = " + att[at]+att[i]+"  | ";
			}
		}
		
		formula = formula.substring(0,formula.length()-2);
		
		formula = formula + " ) -> X ( G diagra.stato !="+att[at]+" ) )";
					   
		return main+formula;
	}
	
	public static String getNuSMV(boolean[][] m, String[] att, int a){
		return getModule(m,att) + getTrans(m,att) + getMain(m,att,a);
	}
	public static String[] eseguiVerifica(boolean[][] m,String[] att){
		String[] risultati = new String[att.length];
		risultati[0] = att[0] + " : Nessun ciclo - Attivita Iniziale\r\n";
		risultati[att.length-1] = att[att.length-1] + " : Nessun ciclo - Attivita Finale\r\n";
		try{
					
			String localDir = (new File (".").getCanonicalPath());
			System.out.println(localDir);
			
			/***************************************************
		     * path del file eseguibile di Nusmv
		     **************************************************/
		     
		    File path = new File("pathNusmv.txt");
			FileInputStream fis = new FileInputStream(path);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader br = new BufferedReader(isr);
			String leva = br.readLine();
			String pathNuSMV = br.readLine();
				
			for(int i = 1; i < att.length-1; i++){
				FileOutputStream file = new FileOutputStream("nusmv/file"+i+".smv");
			    PrintStream Output = new PrintStream(file);
			    Output.println(getNuSMV(m,att,i));
			    Output.close();
			    file.close();
				
				
				File nusmvDir = new File("nusmv");
				File nusmvFile = new File(nusmvDir, "file"+i+".smv");
				String command=pathNuSMV + " \"" + nusmvFile.getCanonicalPath() + "\"";

				System.err.println("Executing command: " + command);

				Process p =Runtime.getRuntime().exec(command);
				
            	File f=new File("nusmv/out"+i+".txt");
				FileOutputStream fos=new FileOutputStream(f);
				PrintStream ps=new PrintStream(fos);

				InputStream out = p.getInputStream();
	            InputStreamReader flusso = new InputStreamReader(out);
	            BufferedReader in = new BufferedReader(flusso);
	            String buffer = in.readLine();
	            
	            System.out.println("Buffer is: " + buffer);
	            
	            while (buffer != null) {
	            	ps.println(buffer);
	            	System.out.println(buffer);
	                buffer = in.readLine();
	            }
	            ps.close();
	            in.close();
	            flusso.close();

			}
			
			for(int i = 1; i < att.length-1; i++){
			   FileReader fr = new FileReader("nusmv/out"+i+".txt");
			   BufferedReader in = new BufferedReader(fr);
			   String str = in.readLine();
			   int k = 1;
			   while(str != null) {
			   		if(k<9){
			      		str = in.readLine();
			      		k++;
			   		}
			      	else
			      		break;
			   }

			   	FileReader fr2 = new FileReader("nusmv/out"+i+".txt");
				BufferedReader in2 = new BufferedReader(fr);
				risultati[i] = att[i] + " : " + in.readLine() + "\r\n";
				String str2 = in.readLine();
				while(str2 != null) {
						risultati[i] = risultati[i] + in.readLine() + "\r\n";
						str2 = in.readLine();
				}
			}
		}catch (Exception e) {
      		System.out.println("Errore: " + e);
      		e.printStackTrace();
    	}
    	
    	return risultati;
	}
}