import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.BevelBorder;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

class CellaGantt extends JLabel{
	int riga;
	int colonna;
	public CellaGantt(String n,int r,int c){ 
		super(n);
		this.riga = r;
		this.colonna = c;
		this.setOpaque(true);
		this.setHorizontalAlignment(JLabel.CENTER);
		this.setBorder(BorderFactory.createBevelBorder(1));
		this.setFocusable(true);
	}
	public int getRiga(){
		return riga;
	}
	public int getColonna(){
		return colonna;
	}
	public void setPosizione(int x, int y, int width,int height){
		this.setBounds(x,y,width,height);
	}
	public void setColore(Color c){
		this.setBackground(c);
	}
	public void addMouse(MouseListener ml){
		this.addMouseListener(ml);
	}
	public void removeMouse(MouseListener ml){
		this.removeMouseListener(ml);
	}
	public void setBorder(BevelBorder f){
		this.setBorder(f);
	}
	public Color getColore(){
		return this.getBackground();
	}
}

public class PanelDisegnoGantt extends JComponent{
	 
	 
	JScrollPane scroll;
	JScrollBar hor;
	JScrollBar ver;
	boolean flagPress;
	
	int riga;
	int colonna;
	int durata;
	
	String gIP;
	String dL;
	String[] giorni;
	int deadL;
	int lunghezzaSel;

	int flagsposta = 0;
	
	int maxSposSin;
	
	boolean click = false;
	
	Point[] assegnazione;
	int ind;
	int precedente;
	
		
	//gestione matrice JLabel
	String[] m;
	CellaGantt[][] matrice;
	boolean[][] sel;
	
	//deadline
	CellaGantt dead;
	int x = 100;
	int y = 200;
	
	public PanelDisegnoGantt(String[] att,String iPG,String dl,boolean[][] matriceSel){
		this.setLayout(null);
		this.setBounds(0,0,4000,600);
		this.setBackground(Color.white);
		
	
		//viene passato al costruttore il giorno di inizio progetto e il giorno di fine progetto
		//il costruttore calcola automaticamente la durata del progetto
		//I Label che compongono la tabella vengono etichettati in modo automatico
	
		gIP = iPG;
		dL = dl;
		
		if(gIP.equals("") && dL.equals("")){
			deadL = 0;
		}else{
			deadL = calcolaDurata(gIP,dL);
		}
		
		durata = matriceSel[0].length;
		
		if(deadL < matriceSel[0].length+20)
			lunghezzaSel = matriceSel[0].length+20;
		else
			lunghezzaSel = matriceSel[0].length+deadL;
		
		this.setPreferredSize(new Dimension(lunghezzaSel*50, 2000));
		
		giorni = new String[lunghezzaSel];
		if(!gIP.equals("") && !dl.equals(""))
			popolaGiorni(gIP,dL);
		m = att;
		
		
		dead = new CellaGantt("",0,0);
		dead.setPosizione(deadL*40+40,0,3,300);
		dead.setColore(Color.red);
		
		creaSel(matriceSel);
		
		creaMatriceLabel();
		
		addMatriceLabel();
		
		creaScroll();
		
	}
	public int calcolaDurata(String i,String f){
		StringTokenizer sti = new StringTokenizer(i);
		StringTokenizer stf = new StringTokenizer(f);
		
		int gi = Integer.parseInt(sti.nextToken());
		int mi = calcolaMese(sti.nextToken());
		int ai = Integer.parseInt(sti.nextToken());
		
		int gf = Integer.parseInt(stf.nextToken());
		int mf = calcolaMese(stf.nextToken());
		int af = Integer.parseInt(stf.nextToken()); 
			
		int dur = 0;
		
		while(!(gi == gf && mi == mf && ai == af)){
			
			if(mi ==1 || mi == 3 || mi == 5 || mi == 7 || mi == 8 || mi == 10 || mi == 12)
				if(gi == 31){
					if(mi==12){
						ai++;
						mi = 1;
					}
					else
						mi++;
					gi = 0;
				}
				else
					gi++;
			else if(mi == 4 || mi == 6 || mi == 9 || mi == 11)
				if(gi==30){
					gi = 0;
					mi++;
				}
				else
					gi++;
			else
				if(gi==28){
					gi = 0;
					mi++;
				}
				else
					gi++;
			dur++;
		}
		return dur+1;
	}
	public void popolaGiorni(String in,String f){
		StringTokenizer sti = new StringTokenizer(in);
		StringTokenizer stf = new StringTokenizer(f);
		
		int gi = Integer.parseInt(sti.nextToken());
		int mi = calcolaMese(sti.nextToken());
		int ai = Integer.parseInt(sti.nextToken());
		
		int gf = Integer.parseInt(stf.nextToken());
		int mf = calcolaMese(stf.nextToken());
		int af = Integer.parseInt(stf.nextToken()); 
		
		giorni[0] = gi + " " + mi + " " + ai;
		int i = 1;
		while(!(gi == gf && mi == mf && ai == af)){
			
			if(mi ==1 || mi == 3 || mi == 5 || mi == 7 || mi == 8 || mi == 10 || mi == 12)
				if(gi == 31){
					if(mi==12){
						ai++;
						mi = 1;
					}
					else
						mi++;
					gi = 1;
					giorni[i] = gi + " " + mi + " " + ai;
				}
				else{
					gi++;
					giorni[i] = gi + " " + mi + " " + ai;
				}
			else if(mi == 4 || mi == 6 || mi == 9 || mi == 11)
				if(gi==30){
					gi = 1;
					mi++;
					giorni[i] = gi + " " + mi + " " + ai;
				}
				else{
					gi++;
					giorni[i] = gi + " " + mi + " " + ai;
				}
			else
				if(gi==28){
					gi = 1;
					mi++;
					giorni[i] = gi + " " + mi + " " + ai;
				}
				else{
					gi++;
					giorni[i] = gi + " " + mi + " " + ai;
				}
			i++;
		}
	}
	public int calcolaMese(String m){
		if(m.equals("Gennaio"))
			return 1;
		if(m.equals("Febbraio"))
			return 2;
		if(m.equals("Marzo"))
			return 3;
		if(m.equals("Aprile"))
			return 4;
		if(m.equals("Maggio"))
			return 5;
		if(m.equals("Giugno"))
			return 6;
		if(m.equals("Luglio"))
			return 7;
		if(m.equals("Agosto"))
			return 8;
		if(m.equals("Settembre"))
			return 9;
		if(m.equals("Ottobre"))
			return 10;
		if(m.equals("Novembre"))
			return 11;
		else
			return 12;
	}
	public void creaScroll(){
		scroll = new JScrollPane();
		scroll.setAutoscrolls(true);
		scroll.setLocation(0,0);
		scroll.setSize(500,500);
		scroll.getViewport().add(this);
				
		flagPress = false;
		hor = scroll.getHorizontalScrollBar();
		ver = scroll.getVerticalScrollBar();
	}
	public JScrollPane getScroll(){
		return scroll;
	}
	public void creaSel(boolean[][] matrice){
		sel = new boolean[matrice.length][lunghezzaSel];
		
		for(int i = 0; i < sel.length;i++){
			for(int j = 0; j < sel[0].length; j++){
				sel[i][j] = false;
			}
		}
		
		for(int i = 0; i < matrice.length;i++){
			for(int j = 0; j < matrice[0].length; j++){
				sel[i][j] = matrice[i][j];
			}
		}
	}

	public void creaMatriceLabel(){	
		
		matrice = new CellaGantt[m.length+1][lunghezzaSel+1];
		
		System.out.println(sel[0].length);
		
		for(int i = 0; i < matrice.length; i++){
			for(int j = 0; j < matrice[0].length; j++){
				if(i==0&&j==0){
					matrice[i][j] = new CellaGantt("Attivita | Durata",i,j);
					matrice[i][j].setColore(Color.blue);
				}else if(i!=0 && j == 0){
					matrice[i][j] = new CellaGantt(m[i-1],i,j);
					matrice[i][j].setColore(Color.blue);
				}else if(i==0 && j!=0){
					matrice[i][j] = new CellaGantt((j-1)+"",i,j);
					matrice[i][j].setColore(Color.yellow);
					matrice[i][j].setToolTipText(giorni[j-1]);
				}else{
					matrice[i][j] = new CellaGantt("",i,j);
					if(sel[i-1][j-1])
						matrice[i][j].setColore(Color.red);
					else
						matrice[i][j].setColore(Color.gray);		
				}
				matrice[i][j].setPosizione(j*40,i*25,40,25);	
			}
		}
			matrice[0][0].setFocusable(true);
			
	}
	public void addMatriceLabel(){
		this.add(dead);
		for(int i = 0; i < m.length+1; i++){
			for(int j = 0; j < lunghezzaSel; j++){
				this.add(matrice[i][j]);
			}
		}
	}
    
   
	public void cancellaSel(int riga){
		for(int i = 1; i < matrice[0].length;i++){
			matrice[riga][i].setColore(Color.gray);
			sel[riga-1][i-1]=false;
		}
	}
	public void controllaPrec(int tmp){
		for(int i = colonna; i <= tmp;i++){
			if(matrice[riga][i].getColore().equals(Color.gray))
				matrice[riga][i].setColore(Color.red);
		}
	}
 	
 	
 	public void updateColor(boolean[] s,int r){
 		for(int i = 0; i < s.length;i++){
 			if(s[i]){
 				matrice[r][i+1].setColore(Color.red);
 			}else{
 				matrice[r][i+1].setColore(Color.GRAY);
 			}
 		}
 	}
 	public int getLungRigaSel(int r){
 		int lung = 0;
 		for(int i = 0;i < lunghezzaSel;i++){
 			if(sel[r-1][i]){
 				lung++;
 			}
 		}
 		return lung;
 	}
 	public int getColonnaSel(int r){
 		int col = 0;
 		for(int i = 0;i < lunghezzaSel;i++){
 			if(sel[r-1][i]){
 				col = i+1;
 				break;
 			}
 		}
 		return col;
 	}
 	
 	public void resetMatrice(){
 		for(int i = 0; i < matrice.length; i++){
			for(int j = 0; j < matrice[0].length; j++){
				matrice[i][j].setVisible(false);
				matrice[i][j] = null;
			}
 		}
 		matrice = null;
		 	
 	}
 	public void aggiornaDeadLine(String ipg,String dl){
 		int durata = calcolaDurata(ipg,dl);
 		dead.setPosizione(durata*40+40,0,3,300);
 	}
 	public void aggiorna(String[] att,String iPG,String dl,boolean[][] matriceSel){
 			
 			resetMatrice();
 		
 		/*	for(int i = 0; i < matriceSel.length; i++){
 				for(int j = 0; j < matriceSel[0].length; j++){
 					if(matriceSel[i][j]){
		 				matrice[i+1][j+1].setColore(Color.red);
		 			}else{
		 				matrice[i+1][j+1].setColore(Color.GRAY);
		 			}
 				}
 			}*/
 		gIP = iPG;
		dL = dl;
		
		if(gIP.equals("") && dL.equals("")){
			deadL = 0;
		}else{
			deadL = calcolaDurata(gIP,dL);
		}
		
		durata = matriceSel[0].length;
		
		if(deadL < matriceSel[0].length+20)
			lunghezzaSel = matriceSel[0].length+20;
		else
			lunghezzaSel = matriceSel[0].length+deadL;
		
		this.setPreferredSize(new Dimension(lunghezzaSel*50, 2000));
		
		giorni = new String[lunghezzaSel];
		if(!gIP.equals("") && !dl.equals(""))
			popolaGiorni(gIP,dL);
		m = att;
		
		creaSel(matriceSel);
		creaMatriceLabel();
		addMatriceLabel();
		
		aggiornaDeadLine(iPG,dl);
 	}
 	public int getDeadLine(){
 		return deadL;
 	}
}
