import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class PannelloAnalisiF extends JPanel implements ActionListener{
	JLabel cosa;
	JComboBox _cosa1;
	
	JLabel riso;
	JTextField _riso;
	String[] risolutori;
	
	JLabel attI;
	JLabel attJ;
	JComboBox aI;
	JComboBox aJ;
	
	JLabel dead;
	JTextField deadL;
	
	JLabel bud;
	JTextField budget;
		
	JButton verifica;
	
	StyledDocument document;
    SimpleAttributeSet attributes;
	JTextPane areaText;
	JScrollPane text;
	
	String diagramma;
	
	Principale principale;
	
	public PannelloAnalisiF(Principale p,String diag){
		this.setLayout(null);
		this.setBounds(0,400,1000,360);
		
		this.diagramma = diag;
		this.principale = p;

		cosa = new JLabel("Proprieta da Verficare");
		cosa.setBounds(50,25,150,25);
		
		//Ogni proprieta della lista verra associato ad un risolutore
		//Ogni risolutore avra associato un indice
		String[] proprieta = getProprieta(diagramma);
		
		_cosa1 = new JComboBox(proprieta);
		_cosa1.setBounds(10,50,250,25);
		_cosa1.setActionCommand("cosa1");
		_cosa1.addActionListener(this);
		_cosa1.setEnabled(true);
		
		riso = new JLabel("Risolutore");
		riso.setBounds(10,100,100,25);
		
		risolutori = new String[]{"Choco","NuSMV"};
		_riso = new JTextField();
		_riso.setBounds(110,100,150,25);
		_riso.setEditable(false);
		
		attI = new JLabel("Attivita A");
		attI.setBounds(10,150,60,25);
		
		aI = new JComboBox(principale.getListaAttivita());
		aI.setBounds(70,150,50,25);
		
		attJ = new JLabel("Attivita B");
		attJ.setBounds(130,150,60,25);
		
		aJ = new JComboBox(principale.getListaAttivita());
		aJ.setBounds(190,150,50,25);
		
		
		verifica = new JButton("Verifica");
		verifica.setBounds(50,250,200,25);
		verifica.addActionListener(this);
		
		document = new DefaultStyledDocument ();
		areaText = new JTextPane(document);
		areaText.setFont(new Font("Mino",Font.ITALIC, 13));
		text = new JScrollPane(areaText);
		text.setBounds(300,0,700,320);

		this.add(cosa);
		this.add(_cosa1);
		this.add(riso);
		this.add(_riso);
		this.add(verifica);
		this.add(text);
	}
	public String[] getProprieta(String diagramma){
		if(diagramma.equals("Gantt")){
			String[] proprieta = {"","Verifica Aciclicita Grafo","Cammino Massimo","Cammino Minimo","Cammino Costo Massimo","Cammino Costo Minimo","Verifica DeadLine"};
			return proprieta;
		}
		if(diagramma.equals("Pert")){
			String[] proprieta = {"","Verifica Aciclicita Grafo","Cammino Massimo","Cammino Minimo","Cammino Costo Massimo","Cammino Costo Minimo"};
			return proprieta;
		}
		return null;
	}
	public void actionPerformed(ActionEvent e){
		String scelta = (String) e.getActionCommand();
		if(scelta.equals("cosa1")){
			if(_cosa1.getSelectedItem().equals("Cammino Massimo"))
				_riso.setText(risolutori[0]);
			if(_cosa1.getSelectedItem().equals("Cammino Minimo"))
				_riso.setText(risolutori[0]);
			if(_cosa1.getSelectedItem().equals("Cammino Costo Massimo"))
				_riso.setText(risolutori[0]);
			if(_cosa1.getSelectedItem().equals("Cammino Costo Minimo"))
				_riso.setText(risolutori[0]);
			if(_cosa1.getSelectedItem().equals("Verifica DeadLine"))
				_riso.setText(risolutori[0]);
			if(_cosa1.getSelectedItem().equals("Verifica Aciclicita Grafo"))
				_riso.setText(risolutori[1]);
		}
		if(scelta.equals("Verifica")){
			
			for(int i = 0; i < principale.getListaAttivita().length; i++){
				System.out.print(principale.getListaAttivita()[i] + " " );
			}
			System.out.println("");
			
			String prop = (String)_cosa1.getSelectedItem();
			if(prop.equals("Cammino Massimo")){
				String[] cammino = Choco.camminoDurataMassimo(principale.getMatriceAdiacenza(),principale.getListaDurate());
				setMessaggio(0,"Cammino Massimo",cammino);
			}
			if(prop.equals("Cammino Minimo")){
				String[] cammino = Choco.camminoDurataMinimo(principale.getMatriceAdiacenza(),principale.getListaDurate());
				setMessaggio(0,"Cammino Minimo",cammino);
			}
			if(prop.equals("Cammino Costo Massimo")){
				String[] cammino = Choco.camminoCostoMassimo(principale.getMatriceAdiacenza(),principale.getListaCosti());
				setMessaggio(0,"Cammino Costo Massimo",cammino);
			}
			if(prop.equals("Cammino Costo Minimo")){
				String[] cammino = Choco.camminoCostoMinimo(principale.getMatriceAdiacenza(),principale.getListaCosti());
				setMessaggio(0,"Cammino Costo Minimo",cammino);
			}
			if(prop.equals("Verifica DeadLine")){
				String[] cammino = Choco.camminoDurataMassimo(principale.getMatriceAdiacenza(),principale.getListaDurate());
				setMessaggio(principale.getDurataDeadLine(),"Verifica DeadLine",cammino);
			}
			if(prop.equals("Verifica Aciclicita Grafo")){
				String[] risultati = NuSMV.eseguiVerifica(principale.getMatriceAdiacenza(),principale.getListaAttivita());
				setMessaggio(0,"Verifica Aciclicita Grafo",risultati);
			}
		}
	}
	public int indiceAttivita(String sel){
		int ind = -1;
		for(int i = 0; i < principale.getListaAttivita().length; i++){
			if(principale.getListaAttivita()[i].equals(sel)){
				ind = i;
				break;
			}
		}
		
		System.out.println(sel + " " + ind);
		return ind;
	}
	public boolean presente(String[] n,String a){
		for(int i = 0; i < n.length; i++){
			if(n[i]!=null)
				if(n[i].equals(a))
					return true;
		}
		return false;
		
	}
	public void setMessaggio(int d,String proprieta,String[] msg){
		try{
			
			attributes = new SimpleAttributeSet ();
			StyleConstants.setForeground (attributes, Color.RED);
			document.insertString (document.getLength (),"************************************************" +  "\n", attributes);
			
			//creiamo il messaggio da stampare a video --> output del risolutore Chocho
			
			if(proprieta.equals("Cammino Massimo") || proprieta.equals("Cammino Minimo")){
				String temp = "";
				String durata = "";
				String cammino = "";
				if(msg != null){
					
					String[] nodi = new String[msg.length+1];
					int[][] grafo = Choco.tabellaGrafo(principale.getMatriceAdiacenza());

					int k = 0;
					int indice = 1;
					for(int j = 0; j < msg.length-1; j++){
						for(int i = 0; i < msg.length-1; i++){
								if(Integer.parseInt(msg[i])==indice){
									if(!presente(nodi,principale.getListaAttivita()[grafo[i][0]])){
										nodi[k] = principale.getListaAttivita()[grafo[i][0]];
										k++;
									}
									if(!presente(nodi,principale.getListaAttivita()[grafo[i][1]])){
										nodi[k] = principale.getListaAttivita()[grafo[i][1]];
										k++;
									}
									indice++;
									break;
								}
						}
					}
					
					for(int i = 0; i < nodi.length; i++){
						if(nodi[i]!=null)
							cammino = cammino + nodi[i] +" " ;
					}
					for(int i = 0; i < msg.length-1; i++){
						temp = temp + msg[i] + " ";
					}
					durata ="" + (Integer.parseInt(msg[msg.length-1]) + principale.getListaDurate()[principale.getListaDurate().length-1]);
					
					attributes = new SimpleAttributeSet ();
					StyleConstants.setForeground (attributes, Color.BLACK);
					document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + temp +  "\n", attributes);
					document.insertString (document.getLength (),"Cammino sul Grafo: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + cammino +  "\n", attributes);
					document.insertString (document.getLength (),"Durata Cammino : " + durata +  "\n", attributes);
				}else{
					attributes = new SimpleAttributeSet ();
					StyleConstants.setForeground (attributes, Color.BLACK);
					document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + "Nessuna Soluzione Trovata" +  "\n", attributes);
				}
			}
			if(proprieta.equals("Cammino Costo Massimo") || proprieta.equals("Cammino Costo Minimo")){
				String temp = "";
				String costo = "";
				String cammino = "";
				if(msg != null){
					
					String[] nodi = new String[msg.length+1];
					int[][] grafo = Choco.tabellaGrafo(principale.getMatriceAdiacenza());
					int k = 0;
					for(int i = 0; i < msg.length-1; i++){
							if(Integer.parseInt(msg[i])>0){
								if(!presente(nodi,principale.getListaAttivita()[grafo[i][0]])){
									nodi[k] = principale.getListaAttivita()[grafo[i][0]];
									k++;
								}
								if(!presente(nodi,principale.getListaAttivita()[grafo[i][1]])){
									nodi[k] = principale.getListaAttivita()[grafo[i][1]];
									k++;
								}
							}
					}
					
					for(int i = 0; i < nodi.length; i++){
						if(nodi[i]!=null)
							cammino = cammino + nodi[i] +" " ;
					}
					for(int i = 0; i < msg.length-1; i++){
						temp = temp + msg[i] + " ";
					}
					
					costo = "" + (Integer.parseInt(msg[msg.length-1]) + principale.getListaCosti()[principale.getListaCosti().length-1]);
					
					attributes = new SimpleAttributeSet ();
					StyleConstants.setForeground (attributes, Color.BLACK);
					document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + temp +  "\n", attributes);
					document.insertString (document.getLength (),"Cammino sul Grafo: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + cammino +  "\n", attributes);
					document.insertString (document.getLength (),"Costo Cammino : " + costo +  "\n", attributes);
				}else{
					attributes = new SimpleAttributeSet ();
					StyleConstants.setForeground (attributes, Color.BLACK);
					document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + "Nessuna Soluzione Trovata" +  "\n", attributes);
				}
			}
			if(proprieta.equals("Verifica DeadLine")){
				
				String temp = "";
				String durata = "";
				String cammino = "";
				if(msg != null){
					String[] nodi = new String[msg.length+1];
					int[][] grafo = Choco.tabellaGrafo(principale.getMatriceAdiacenza());
					int k = 0;
					for(int i = 0; i < msg.length-1; i++){
							if(Integer.parseInt(msg[i])>0){
								if(!presente(nodi,principale.getListaAttivita()[grafo[i][0]])){
									nodi[k] = principale.getListaAttivita()[grafo[i][0]];
									k++;
								}
								if(!presente(nodi,principale.getListaAttivita()[grafo[i][1]])){
									nodi[k] = principale.getListaAttivita()[grafo[i][1]];
									k++;
								}
							}
					}
					
					for(int i = 0; i < nodi.length; i++){
						if(nodi[i]!=null)
							cammino = cammino + nodi[i] +" " ;
					}
					for(int i = 0; i < msg.length-1; i++){
						temp = temp + msg[i] + " ";
					}
					durata ="" + (Integer.parseInt(msg[msg.length-1]) + principale.getListaDurate()[principale.getListaDurate().length-1]);
					
					if(Integer.parseInt(durata) <= d){
						attributes = new SimpleAttributeSet ();
						StyleConstants.setForeground (attributes, Color.BLACK);
						document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
						document.insertString (document.getLength (),proprieta + " : " + temp +  "\n", attributes);
						document.insertString (document.getLength (),"Cammino sul Grafo: " +  "\n", attributes);
						document.insertString (document.getLength (),proprieta + " : " + cammino +  "\n", attributes);
						document.insertString (document.getLength (),"Durata Cammino : " + durata +  " - DeadLine Rispettata = " + d + "\n", attributes);
					}else{
						attributes = new SimpleAttributeSet ();
						StyleConstants.setForeground (attributes, Color.BLACK);
						document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
						document.insertString (document.getLength (),proprieta + " : " + temp +  "\n", attributes);
						document.insertString (document.getLength (),"Cammino sul Grafo: " +  "\n", attributes);
						document.insertString (document.getLength (),proprieta + " : " + cammino +  "\n", attributes);
						document.insertString (document.getLength (),"Durata Cammino : " + durata +  " - DeadLine Non Rispettata = " + d + "\n", attributes);
					}
				}else{
					
					System.out.println("msg null");
					
					attributes = new SimpleAttributeSet ();
					StyleConstants.setForeground (attributes, Color.BLACK);
					document.insertString (document.getLength (),"Output Choco: " +  "\n", attributes);
					document.insertString (document.getLength (),proprieta + " : " + "Nessuna Soluzione Trovata" +  "\n", attributes);
				}
			}
			if(proprieta.equals("Verifica Aciclicita Grafo")){
				attributes = new SimpleAttributeSet ();
				StyleConstants.setForeground (attributes, Color.BLACK);
				document.insertString (document.getLength (),"Output NuSMV: " +  "\n", attributes);
				document.insertString (document.getLength (),proprieta +"\n", attributes);
				for(int i = 0; i < msg.length; i++){
					document.insertString (document.getLength (),msg[i], attributes);
				}
			}
		}catch(Exception ex){
			System.out.println(ex.getMessage());
		}
	}
}