import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Principale extends JFrame implements ActionListener{
	//Finestra scelta
	FrameScelta frameScelta;
	
	//Finestra visualizza Diagramma
	VisualizzaDiagramma visualizza;
	
	//pannello Gantt
	PanelDisegnoGantt gantt;
	
	//pannello Pert
	PanelDisegnoPert pert;
	
	//Pannello Analisi
	PannelloAnalisiF pannello;

	//Pannello opzioni diagramma;
	PanelOpzioniDiagramma panelOpDiag;
	
	//Gestione informazioni diagrammi
	//matrice SEL booleana
	boolean[][] sel;
	String[] attivita;
	String iPG;
	String dL;
	boolean[][] matriceAd;
	int[] durate;
	int[] costi;
	String[] descrizioni;
	String nome;
	
	String diagramma;
	
	//dimensione schermo
	Toolkit tool;
    Dimension d;
    
    //coordinate 
    int x;
    int y;
    
    //grandezza
    int width;
    int height;
    
    //componenti frame
    Container container;
    JMenuBar menubar;
    JMenu menu;
    JMenu info;
    JMenuItem nuovo;
    JMenuItem salva;
    JMenuItem esci;
    JMenuItem help;
    
    public Principale(String diag,String nome,String[] att,String ipg,String dl,boolean[][] selb,boolean[][] matrice,int[] dur,int[] costi,String[] des){
    	super(diag + " - Nome Progetto : " + nome);
    	
    	//assegnazione informazioni diagrammi
    	this.sel = selb;
    	this.attivita = att;
    	this.iPG = ipg;
    	this.dL = dl;
    	this.matriceAd = matrice;
    	this.durate = dur;
    	this.diagramma = diag;
    	this.costi = costi;
    	this.descrizioni = des;
    	this.nome = nome;
    	
    	tool=Toolkit.getDefaultToolkit();
        d=tool.getScreenSize();
        
        container = this.getContentPane();
        container.setLayout(null);
        
        //aggiungo il menu
        menubar = new JMenuBar();
        menu = new JMenu("File");
        info = new JMenu("Info");
        nuovo = new JMenuItem("Nuovo");
        esci = new JMenuItem("Esci");
        salva = new JMenuItem("Salva Progetto");
        help = new JMenuItem("Aiuto");
        
        nuovo.addActionListener(this);
        esci.addActionListener(this);
        
        menu.add(nuovo);
        menu.add(salva);
        menu.add(esci);
        info.add(help);
        menubar.add(menu);
        menubar.add(info);
        
        setJMenuBar(menubar); 
        
        if(diagramma.equals("Gantt")){
	        gantt = new PanelDisegnoGantt(attivita,iPG,dL,sel);
	        gantt.getScroll().setBounds(0,0,1000,375);
	        
	        panelOpDiag = new PanelOpzioniDiagramma("Gantt",this);
	        panelOpDiag.setBounds(0,375,1000,25);
	        
	        container.add(gantt.getScroll());
	        container.add(panelOpDiag);
        }else if(diagramma.equals("Pert")){
	        pert = new PanelDisegnoPert(matriceAd,attivita,durate);
			pert.getScroll().setBounds(0,0,1000,375);
			
			panelOpDiag = new PanelOpzioniDiagramma("Pert",this);
	        panelOpDiag.setBounds(0,375,1000,25);
	        
			container.add(pert.getScroll());
			container.add(panelOpDiag);
        }else{
        	gantt = new PanelDisegnoGantt(attivita,iPG,dL,sel);
	        gantt.getScroll().setBounds(0,0,500,370);
	        container.add(gantt.getScroll());
	        
        	pert = new PanelDisegnoPert(matriceAd,attivita,durate);
			pert.getScroll().setBounds(500,0,500,375);
			container.add(pert.getScroll());
			
			panelOpDiag = new PanelOpzioniDiagramma("Gantt vs Pert",this);
	        panelOpDiag.setBounds(0,375,1000,25);
	        container.add(panelOpDiag);
        }
		
		pannello = new PannelloAnalisiF(this,diagramma);
		container.add(pannello);
		
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	this.setBounds((d.width/2)-512,30,1014,780);
    	this.setResizable(false);
    	this.show();
    }
    public String getNome(){
    	return nome;
    }
    public int[] getListaCosti(){
    	return costi;
    }
    public String[] getListaDescrizioni(){
    	return descrizioni;
    }
    public String[] getListaAttivita(){
    	return attivita;
    }
    public int[] getListaDurate(){
    	return durate;
    }
    public String getInizio(){
    	return iPG;
    }
    public String getDeadLine(){
    	return dL;
    }
    public int getDurataDeadLine(){
    	return gantt.getDeadLine();
    }
    public boolean[][] getMatriceSel(){
    	return sel;
    }
    public boolean[][] getMatriceAdiacenza(){
    	return matriceAd;
    }
    public void actionPerformed(ActionEvent e){
    	String scelta = (String) e.getActionCommand();
    	if(scelta.equals("Visualizza Pert")){
    		visualizza = new VisualizzaDiagramma("Pert",this);
    	}
    	if(scelta.equals("Visualizza Gantt")){
    		visualizza = new VisualizzaDiagramma("Gantt",this);
    	}
    	if(scelta.equals("Modifica Gantt")){
    		frameScelta = FrameScelta.getFrameScelta(this,"Gantt");
    	}
    	if(scelta.equals("Modifica Pert")){
    		frameScelta = FrameScelta.getFrameScelta(this,"Pert");
    	}
    	if(scelta.equals("Nuovo")){
    		frameScelta = FrameScelta.getFrameScelta(this,"Nuovo");
    		this.setVisible(false);
    	}
    	if(scelta.equals("Esci")){
    		System.exit(0);
    	}
    }
    public void aggiorna(String diag,String nome,String[] att,String ipg,String dl,boolean[][] selb,boolean[][] matrice,int[] dur,int[] costi,String[] des){
    	//aggiorno i valori delle informazioni
    	this.sel = selb;
    	this.attivita = att;
    	this.iPG = ipg;
    	this.dL = dl;
    	this.matriceAd = matrice;
    	this.durate = dur;
    	this.diagramma = diag;
    	this.costi = costi;
    	this.descrizioni = des;
    	this.nome = nome;
    	
    	if(diag.equals("Gantt")){
    		gantt.aggiorna(attivita,iPG,dL,sel);
    	}
    	else{
    		pert.aggiorna(matriceAd,attivita,durate);
    	}
    }
}